'' =================================================================================================
''
''   File....... jm_servo8_measure_test.spin 
''   Purpose.... 
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2010 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.term
''   Started.... 
''   Updated.... 21 DEC 2010
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1 = 31
  TX1 = 30
  SDA = 29
  SCL = 28


con 

  ' PST formmatting control
  
  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, GOTOX, #16, CLS      


obj

  term   : "fullduplexserial"
  svoout : "jm_servo8"
  svoin  : "jm_servo8_measure"


var

  long  stack[64]


pub main | t, idx

  svoout.init(8, 0)                                             ' servo outputs, 16..23
  svoin.init(0)                                                 ' servo inputs, 16..23

  term.start(RX1, TX1, %0000, 115_200)
  pause(1)

  cognew(wagservos, @stack)                                     ' wag servos to and fro

  term.tx(CLS)
  term.str(string("Servo Measure"))

  t := cnt
  repeat
    term.tx(HOME)
    term.tx(CR)
    term.tx(CR)
    repeat idx from 1 to 8
      term.tx("0" + idx)
      term.tx(" ")
      term.tx(":")
      term.tx(" ")
      term.dec(svoout.getpos(idx))
      term.tx(" ")
      term.tx(" ")
      term.tx(GOTOX)
      term.tx(10)
      term.dec(svoin.getpos(idx))
      term.tx(CLREOL)
      term.tx(CR)    
      
    waitcnt(t += constant(MS_001 * 100))

 
pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)


pri wagservos | t, pos                                          ' call with cognew

'' wag servos in background for testing

  t := cnt
  repeat
    repeat pos from 600 to 2400 step 5
      svoout.setall(pos)
      waitcnt(t += constant(20 * MS_001))

    repeat pos from 2400 to 600 step 20
      svoout.setall(pos)
      waitcnt(t += constant(20 * MS_001))

                      
dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}